__package__    = "mtdb"
__version__    = "0.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/mtdb/"
__cvsversion__ = "$Revision: 1.7 $"
__date__       = "$Date: 2007/08/30 06:35:53 $"
__copyright__  = "Copyright (c) 2007 Aaron Straup Cope. Perl Artistic License."

class document :
    def __init__ (self, row):
        self.id = row[0]
        self.document_uri = row[1]

    def as_string (self) :
        return self.document_uri

    def __str__ (self) :
        return self.as_string()

    def __unicode__ (self) :
        return self.as_string()
    
class documentstore :

    def __init__ (self, dbconn) :
        self.__dbconn = dbconn

    #
    
    def store (self, document_uri) :
        sql = "INSERT INTO documentstore (document_uri) VALUES (?)"
        self.__dbconn.execute(sql, (document_uri, ))
        self.__dbconn.commit()

    #
    
    def retrieve (self, document_uri, expand=False) :
        sql = "SELECT * FROM documentstore WHERE document_uri=?"
        cur = self.__dbconn.execute(sql, (document_uri, ))
        res = cur.fetchone()

        if not expand :
            return res

        if res :
            return document(res)

    #
    
    def retrieve_by_id (self, id, expand=False) :
        sql = "SELECT * FROM documentstore WHERE id=?"
        cur = self.__dbconn.execute(sql, (id, ))
        res = cur.fetchone()
        
        if not expand :
            return res

        return document(res)
